unit DemoU;
{
    TAFrame Examples for Delphi 4 - 5                              12/15/00

	Copyright  2000  PeakStars
        Eberhard Beck, <eb@lettas.com>


}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, Spin, Buttons, ExtCtrls, ClipBrd, JPeg, ComCtrls, Menus, aFrame;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Timer1: TTimer;
    PopupMenu2: TPopupMenu;
    ZoomUp1: TMenuItem;
    ZoomDown1: TMenuItem;
    Panel6: TPanel;
    Label9: TLabel;
    seX: TSpinEdit;
    seY: TSpinEdit;
    Label10: TLabel;
    seH: TSpinEdit;
    Label12: TLabel;
    seW: TSpinEdit;
    Label11: TLabel;
    Panel10: TPanel;
    rbWin: TRadioButton;
    rbRun: TRadioButton;
    rbFlat: TRadioButton;
    sEdBorderW: TSpinEdit;
    Label5: TLabel;
    Label8: TLabel;
    cbColors: TComboBox;
    bbNewFrame: TBitBtn;
    bbDeleteFrame: TBitBtn;
    Panel12: TPanel;
    Panel11: TPanel;
    rbOuter: TRadioButton;
    rbInner: TRadioButton;
    PageControl1: TPageControl;
    TSDemo1: TTabSheet;
    Panel13: TPanel;
    Panel3: TPanel;
    Image2: TImage;
    Panel7: TPanel;
    bbZoom: TBitBtn;
    bbGDI: TBitBtn;
    bbClient: TBitBtn;
    TSDemo2: TTabSheet;
    Panel5: TPanel;
    Panel8: TPanel;
    bbLoad: TBitBtn;
    bbCopy: TBitBtn;
    bbPaste: TBitBtn;
    Frame1: TAFrame;
    Frame2: TAFrame;
    Frame3: TAFrame;
    Panel2: TPanel;
    Panel9: TPanel;
    Image1: TImage;
    Demo5: TAFrame;
    Demo4: TAFrame;
    bbTestBtn: TBitBtn;
    Frame4: TAFrame;
    Bevel1: TBevel;
    TabSheet1: TTabSheet;
    Memo1: TMemo;
    AFrame1: TAFrame;
    procedure bbNewFrameClick(Sender: TObject);
    procedure ChangeFrameProperties(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure bbDeleteFrameClick(Sender: TObject);
    procedure bbGDIClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure bbZoomClick(Sender: TObject);
    procedure ZoomClick(Sender: TObject);
    procedure bbDemo3Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FrameBoundsChanged(Sender: TObject);
    procedure FrameChanged(Sender: TObject);
    procedure bbLoadClick(Sender: TObject);
    procedure bbPasteClick(Sender: TObject);
    procedure bbCopyClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    LastR          : TRect;
    InhibitChanges : Bool;
    myBitmap       : TBitmap;
    Zoom           : single;
    Images         : TList;
    CurImg         : Integer;
    FrameDlta      : Integer;
    ImPanel2,
    ImPanel3       : TPanel;
    DemoImage2,
    DemoImage3     : TImage;
    Procedure CreateFrame(var aF : TAFrame; aParent : TWinControl;aName : string);
    Function  MakeComposedImageControl(aName : string;x,y,wi,he : Integer;
                 aParent:TWinControl;var ImPanel:TPanel;var DemoImage:TImage):TAFrame;
    Procedure ShowImage;
    procedure LoadImages;
  end;

var
  Form1    : TForm1;
  ResNames : TStringList;

implementation
{$R IMAGES.RES}     //Image series
{$R *.DFM}

{- utilities -}
Procedure TForm1.CreateFrame(var aF : TAFrame; aParent : TWinControl;aName : string);
          { standard Frame Creation for this unit}
begin
  aF := TAFrame.create(self);
  aF.visible   := False;                // hide until Frame has final position
  aF.Parent    := aParent;
  aF.OnBoundsChanged :=  FrameBoundsChanged;
  aF.OnFrameChanged  :=  FrameChanged;
  if aName <> '' then
    aF.Name      := aName;
end;

Function TForm1.MakeComposedImageControl(aName : string;x,y,wi,he : Integer;
                 aParent:TWinControl;var ImPanel:TPanel;var DemoImage:TImage):TAFrame;
         {Creates a composed image-control consisting of a Frame having as client
          a TPanel with a TImage on it }
begin
  result := mFrames.GetFrameByName(aName);
  if result <> nil then begin
    result.free;
    ImPanel.free;
  end;
  CreateFrame(result,self,aName);
  ImPanel   := TPanel.create(self);
  ImPanel.Visible := False;             // hide until Control has final position
  DemoImage := TImage.create(ImPanel);
  DemoImage.Parent   := Impanel;
  DemoImage.Align    := alClient;
  ImPanel.BevelOuter := bvNone;
  ImPanel.FullRepaint:= False;          // suppress flickering
  ImPanel.Parent     := aParent;
  ImPanel.SetBounds(x,y,wi,he);
  result.ClientControl  := ImPanel; { implicitly sets Frame Parent to client's parent}
  ImPanel.Visible := True;
  result.visible := True;
end;

{ - Frame Notifications - }

procedure TForm1.FrameChanged(Sender: TObject);
var aF      : TAFrame;
    aR      : TRect;
    ColStr  : string;
Begin
  { Show properties of the currently active Frame }
  aF := TAFrame(Sender);
  aR := aF.GetBounds;
  Panel12.Caption  := aF.Name;
  InhibitChanges := True;               // don't propagate properties back
  seX.Value := aR.Left;
  seY.Value := aR.Top;
  seW.Value := aR.Right;
  seH.Value := aR.Bottom;
  case aF.FrameStyle of
     fsWindow : rbWin.Checked  := true;
     fsFlat   : rbFlat.Checked := true;
     fsRunning: rbRun.Checked  := true;
  end;
  case aF.RectStyle of
     rsInnerFrame : rbInner.Checked  := true;
     rsOuterFrame : rbOuter.Checked := true;
  end;
  sEdBorderW.Value := aF.BorderWidth;
  ColStr := ColorToString(aF.Color);
  Delete(ColStr,1,2);
  cbColors.ItemIndex := cbColors.Items.IndexOf(ColStr);
  InhibitChanges := False;
End ;

procedure TForm1.FrameBoundsChanged(Sender: TObject);
var aF  : TAFrame;
    dc  : HDC;
    sR, dR  : TRect;
    myBMP   : TBitmap;
    fr,fb   : single;
begin
  { Show current bounds }
  aF := TAFrame(Sender);
  sR := aF.GetBounds;
  InhibitChanges := True;               // don't propagate properties back
  seX.Value := sR.Left;
  seY.Value := sR.Top;
  seW.Value := sR.Right;
  seH.Value := sR.Bottom;
  sEdBorderW.Value := aF.BorderWidth;
  InhibitChanges := False;
  { Demo actions }
  if aF.Name = 'Demo4' then begin
    { adjust the client's child to the new bounds}
    sR := aF.GetBounds;
    with Panel2 do
      SetBounds(Left,Top, sR.Right - Left - 14, sR.Bottom - Top - 13);
  end else
  if aF.Name = 'Zoom1' then begin
    sR := aF.GetBounds;
    dR := Rect(0,0,sR.Right,sR.Bottom);
    fr := sR.Right; fb := sR.Bottom;
    sR := Rect(sR.Left,sR.Top,sR.Left + Round(fr/Zoom),sR.Top  + Round(fb/Zoom));
    myBMP   := TBitmap.create;
    myBmp.height := dR.Bottom;
    myBmp.width  := dR.Right;
    myBMP.Canvas.CopyRect(dR,myBitmap.Canvas,sR);
    DemoImage2.Picture.Assign(myBMP);
    myBMP.free;
    ValidateRect(ImPanel2.handle,@dR);  // suppress flickering, we do the painting
    dc := GetDC(ImPanel2.Handle);
    BitBlt(dc,0,0,dR.Right,dR.Bottom,DemoImage2.Canvas.handle,0,0,SRCCOPY);
    ReleaseDC(ImPanel2.Handle,dc);
  end else if aF.Name = 'Ellipse1' then with Image2.Canvas do begin
    pen.mode    := pmCopy;
    pen.Color   := clYellow;
    Brush.Style := bsClear;
    CopyRect(LastR,myBitmap.Canvas,LastR); // Erase the Last Drawing
    dc := GetDC(Panel3.Handle);
    with LastR do
      BitBlt(dc,Left,Top,Right,Bottom,Image2.Canvas.handle,Left,Top,SRCCOPY);
    dR := aF.GetBounds;
    LastR := dR;                          // Draw a new ellipse.
    LastR.Right := LastR.Left + LastR.Right;
    LastR.Bottom := LastR.Top + LastR.Bottom;
    Ellipse(LastR.Left,LastR.Top,LastR.Right,LastR.Bottom);
    sR := Rect(0,0,Panel3.Width,Panel3.Height);
    ValidateRect(Panel3.handle,@sR);    // suppress flickering, we do the painting
    BitBlt(dc,dR.Left,dR.Top,dR.Right,dR.Bottom,Image2.Canvas.handle,LastR.Left,LastR.Top,SRCCOPY);
    ReleaseDC(Panel3.Handle,dc);
  end;
end;

{ - General - }

procedure TForm1.ChangeFrameProperties(Sender: TObject);
  procedure ChangeColor(aF : TAFrame;Col, iaCol1, iaCol2 : TColor);
  begin
     aF.Color := Col;
     if aF.FrameStyle = fsRunning then
       aF.ColorInActive  := iaCol1
     else
       aF.ColorInActive  := iaCol2;
  end;
begin
  with mFrames do begin
    if (ActiveFrame = nil) or InhibitChanges then exit;
    if (Sender = seX) or (Sender = seY) or (Sender = seW) or (Sender = seH) then
    begin
      if ActiveFrame.RectStyle = rsInnerFrame then
        ActiveFrame.SetInnerBounds(seX.Value,seY.Value,seW.Value,seH.Value)
      else
        ActiveFrame.SetBounds(seX.Value,seY.Value,seW.Value,seH.Value);
    end
    else if Sender = rbWin then
      ActiveFrame.FrameStyle  := fsWindow
    else if Sender = rbRun    then
      ActiveFrame.FrameStyle  := fsRunning
    else if Sender = rbFlat   then
      ActiveFrame.FrameStyle  := fsFlat
    else if Sender = rbOuter  then
      ActiveFrame.RectStyle   := rsOuterFrame
    else if Sender = rbInner  then
      ActiveFrame.RectStyle   := rsInnerFrame
    else if Sender = sEdBorderW then
      ActiveFrame.BorderWidth := sEdBorderW.Value
    else if Sender = cbColors   then begin
      if cbColors.Text = 'Blue' then
        ChangeColor(ActiveFrame,clBlue,clWhite,clFuchsia)
      else if cbColors.Text = 'White' then
         ChangeColor(ActiveFrame,clWhite,clBlack,clBlack)
      else if cbColors.Text = 'Yellow' then
         ChangeColor(ActiveFrame,clYellow,clBlack,clGreen)
      else if cbColors.Text = 'Fuchsia' then
         ChangeColor(ActiveFrame,clFuchsia,clWhite,clRed)
    end;
  end;
end;

procedure TForm1.bbNewFrameClick(Sender: TObject);
var aF : TAFrame;
begin
  CreateFrame(aF,Panel3,'');
  aF.RectStyle := rsInnerFrame;
  aF.Cursor := crHandPoint;
  aF.visible := True;
end;

procedure TForm1.bbDeleteFrameClick(Sender: TObject);
begin
  with mFrames do begin
    if ActiveFrame <> nil then
      if (ActiveFrame.Name = 'Zoom1') then begin
        ImPanel2.free;
        ActiveFrame.free;
        exit;
      end else
      if (ActiveFrame.Name = 'Demo3') then begin
        ActiveFrame.free;
        exit;
      end;
    { Don't delete Designtime frames }
    if assigned(ActiveFrame.ClientControl) then exit;
    ActiveFrame.free;
  end;
end;

{ - Examples Page 1 - }

procedure TForm1.ZoomClick(Sender: TObject);
begin
  if Sender = ZoomDown1 then
    Zoom := Zoom/2
  else if Sender = ZoomUp1 then
    Zoom := Zoom*2
  else if Sender is TAFrame then
    { User DblClicked }
    if TAFrame(Sender).Name = 'Zoom1' then begin
      if ssLeft in TAFrame(Sender).Buttons then
        Zoom := Zoom*2
      else
        Zoom := Zoom/2;
    end;
  if mFrames.ActiveFrame <> nil then
    FrameBoundsChanged(mFrames.ActiveFrame); //Show the new Zoom
end;

procedure TForm1.bbGDIClick(Sender: TObject);
var aF : TAFrame;
begin
  try
    CreateFrame(aF,Panel3,'Ellipse1');
    aF.ColorInactive  := clBlack;
    aF.FrameStyle  := fsRunning;
    aF.RectStyle   := rsInnerFrame;
    aF.Cursor      := crHandPoint;
  finally
    aF.visible     := True;
  end;
end;

procedure TForm1.bbZoomClick(Sender: TObject);
var aF : TAFrame;
begin
  aF := MakeComposedImageControl('Zoom1',50,150,80,80,Panel3,ImPanel2,DemoImage2);
  aF.PopupMenu        := PopUpMenu2;
  ImPanel2.PopupMenu   := PopUpMenu2;
  aF.OnDblClick       := ZoomClick;
end;

procedure TForm1.bbDemo3Click(Sender: TObject);
var aF : TAFrame;
begin
  aF := mFrames.GetFrameByName('Demo3');
  if aF <> nil then         { already there, make a new one }
    aF.free;
  bbTestBtn.BringToFront;
  CreateFrame(aF,Form1,'Demo3');
  aF.ClientControl := bbTestBtn;
  aF.FrameStyle  := fsRunning;
  aF.BorderWidth := 2;
  aF.Visible := True;
  FrameChanged(aF);
end;

{ - More Examples Page 2 - }

{ Load the resource imageseries to Images List}
Function EnumNameProc(hModule : HGLOBAL;lpszType,lpszName : PChar;lp :LParam) : Boolean stdcall;
Begin
  Result := True;
  ResNames.Add(lpszName);
end;

Procedure TForm1.LoadImages;
var aStream       : TMemoryStream;
    mlParam, i    : LongInt;
    ResType       : string;
    aRS           : TResourceStream;
    myjpg : TJPEGImage;
    mybmp : TBitmap;
begin
  Images := TList.create;
  CurImg := 1;
  aStream  := TMemoryStream.create;
  ResNames := TStringList.create;
  try
    ResType := 'JPGS';
    EnumResourceNames(HInstance,PChar(ResType),@EnumNameProc,mlParam);
    for i := 0 to ResNames.Count - 1 do begin
      aRS  := TResourcestream.create(hInstance, ResNames[i],PChar(ResType));
      aStream.CopyFrom(aRS,aRS.Size);
      aStream.Position := 0;
      myjpg := TJPEGImage.Create;
      mybmp := TBitmap.Create;
      myjpg.LoadFromStream(aStream);
      myjpg.DibNeeded;
      mybmp.Assign(myjpg);
      Images.add(mybmp);
      myJpg.free;
      aStream.SetSize(0);
      aStream.Position := 0;
      aRS.free;
    end;
  finally
    aStream.free;
    ResNames.free;
  end;
end;

{ Show the Image series }
Procedure TForm1.ShowImage;
var sR,dR     : TRect;
    dc        : HDC;
    myBMP     : TBitmap;
begin
  if Images.Count - 1 < CurImg then exit;
  with TBitmap(Images[CurImg]) do
    sR := Rect(0,0,width,height);
  dR := Rect(0,0,Image1.clientwidth,Image1.clientheight);
  myBMP   := TBitmap.create;
  myBmp.height := dR.Bottom;
  myBmp.width  := dR.Right;
                                     //Image-stretching takes time
  myBMP.Canvas.CopyRect(dR,TBitmap(Images[CurImg]).Canvas,sR);
  Image1.Picture.Assign(myBMP);
  myBMP.free;
  ValidateRect(panel9.handle,@dR);   // suppress flickering, we do the painting
  dc := GetDC(Panel9.Handle);
  BitBlt(dc,0,0,dR.Right,dR.Bottom,
                             Image1.Picture.Bitmap.Canvas.handle,0,0,SRCCOPY);
  ReleaseDC(Panel9.Handle,dc);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if not assigned(Images) then  exit;
  ShowImage;
  inc(CurImg,FrameDlta);
  if (CurImg >= Images.Count -1) or (CurImg <= 0) then
     FrameDlta := -FrameDlta;
end;

{ Load, Copy and Paste }
procedure TForm1.bbLoadClick(Sender: TObject);
begin
  Frame1.SetFocus;                      // looks nicer
  if not assigned(Images) then begin
    Frame1.Color := clYellow;           // play around with colors
    LoadImages;
    Timer1Timer(Self);                  // show the first image
    Frame2.Color := clGreen;
    Demo4.FrameStyle    := fsWindow;    // play around with colors
    Demo4.Color         := clFuchsia;
    Demo4.ColorInActive := clTeal;
  end else begin
    if Timer1.Enabled then
      Frame1.Color := clWhite
    else
      Frame1.Color := clYellow;
  end;
  Timer1.Enabled := not Timer1.Enabled;
end;

procedure TForm1.bbCopyClick(Sender: TObject);
var aF  : TAFrame;
    sR, dR  : TRect;
    myBMP   : TBitmap;
begin
  Frame2.SetFocus;                      // looks nicer
  if not assigned(Images) then
    bbLoadClick(Self);
  aF := mFrames.GeTFrameByName('Demo5');
  sR := aF.GetBounds;
  dR := Rect(0,0,sR.Right,sR.Bottom);
  sR.Right  := sR.Left + sR.Right;
  sR.Bottom := sR.Top  + sR.Bottom;
  myBMP        := TBitmap.create;
  myBmp.height := dR.Bottom; myBmp.width  := dR.Right;
  myBMP.Canvas.CopyRect(dR,Image1.Picture.Bitmap.Canvas,sR);
  ClipBoard.Assign(myBmp);
  myBMP.free;
  Frame3.Color := clGreen;
end;

procedure TForm1.bbPasteClick(Sender: TObject);
var myBMP   : TBitmap;
begin
  if not assigned(Images) or not ClipBoard.HasFormat(CF_BITMAP) then
    bbCopyClick(Self);
  Frame3.SetFocus;                      // looks nicer
  myBMP   := TBitmap.create;
  myBmp.Assign(Clipboard) ;
  MakeComposedImageControl('Demo6',5,TSDemo2.height - myBmp.height - 5,
                            myBmp.width,myBmp.height,TSDemo2,ImPanel3,DemoImage3);
  DemoImage3.Picture.Bitmap.Assign(myBmp);
  myBMP.free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Zoom := 2;
  FrameDlta := 1;
  InhibitChanges := False;
  myBitmap := TBitmap.create;   // double buffer Image2 for erasing with GDI demo
  myBitmap.assign(Image2.Picture.Bitmap);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  myBitmap.free;
  if assigned(Images) then begin
    while Images.count > 0  do begin
      TBitmap(Images[Images.Count - 1]).free;
      Images.delete(Images.Count - 1)
    end;
    Images.free;
  end;
end;

end.

